import os
import socket

from sziszapangma.integration.service_core.asr.asr_base_processor import AsrBaseProcessor
from sziszapangma.integration.service_core.asr.asr_result import AsrResult

from dictation_client import recognise


class TechmoAsrProcessor(AsrBaseProcessor):

    @staticmethod
    def is_tunnel_running() -> bool:
        with socket.socket(socket.AF_INET, socket.SOCK_STREAM) as s:
            return s.connect_ex(('localhost', 12321)) == 0

    def process_asr(self, audio_file_path: str) -> AsrResult:
        print(f'processing start {audio_file_path}')
        if not self.is_tunnel_running():
            os.system('./start_tunneling.sh')
        raw_transcription, words_time_alignment = recognise(audio_file_path, True)
        transcription = raw_transcription.replace('\n', ' ')
        words = [
            it
            for it in transcription.split(' ')
            if it not in ['', ' ']
        ]
        asr_result = AsrResult(words, transcription, words_time_alignment)
        print(f'processing end {audio_file_path}, {asr_result}')
        return asr_result


if __name__ == '__main__':
    TechmoAsrProcessor().start_processor()
